#pragma config(StandardModel, "EV3_REMBOT")
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/*
Create a program to drive the robot backwards with a warning beep getting quicker
as the Ultrasonic Sensor sees an approaching object. The beep only sounds at a distance
less than 20cm. The robot slows down as it nears the object.
The robot stops when a distance of less than 4cm is reached as does
the beeper.
*/

task distanceBeeper()
{
	while(true)
	{
		if (getUSDistance(sonarSensor) < 20){

			//Start playing a tone (length determined by distance).
			playTone(440, (getUSDistance(sonarSensor)));

			//Delay for the length of the tone.
			//Wait while the sound is playing.
			while (bSoundActive)
			{
				sleep(10);
			}

			//Add 50ms of "silence" to avoid a constant tone.
			sleep(50);
		}
	}
}

task main()
{
	//Start the "distance beeper" task.
	startTask(distanceBeeper);

	while(SensorValue(sonarSensor) >= 4)
	{
		setMotorSpeed(motorB, -getUSDistance(sonarSensor));
		setMotorSpeed(motorC, -getUSDistance(sonarSensor));
		sleep(50);
	}

	//Set motor speed to 0 and stop the distanceBeeper loop.
	setMotorSpeed(motorB, 0);
	setMotorSpeed(motorC, 0);
	stopTask(distanceBeeper);
}
